﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApp1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Model model = new Model();

        public MainWindow()
        {
            InitializeComponent();

            model.OdebranoNowąWiadomość += Model_OdebranoNowąWiadomość;
        }

        private void odświeżListBox()
        {
            listBox.Items.Clear();
            foreach (string wiadomość in model.Wiadomości)
                listBox.Items.Add(wiadomość);
        }

        private void Model_OdebranoNowąWiadomość(object sender, EventArgs e)
        {
            Application.Current.Dispatcher.Invoke(odświeżListBox, System.Windows.Threading.DispatcherPriority.Normal);            
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Action a = () => { model.OdbierzWiadomości(); };
            Task.Run(a);
        }
    }

    class Model
    {
        public List<string> Wiadomości = new List<string>();

        public event EventHandler OdebranoNowąWiadomość;

        public void OdbierzWiadomości()
        {
            for (int i = 0; i < 100; i++)
            {
                Wiadomości.Add(i.ToString());
                if (OdebranoNowąWiadomość != null) OdebranoNowąWiadomość(this, EventArgs.Empty);
                System.Threading.Thread.Sleep(100);
            }
        }
    }
}
